
from sklearn.feature_extraction import DictVectorizer
from sklearn.linear_model import Perceptron
from sklearn.svm import LinearSVC, SVC
from sklearn.metrics import accuracy_score

import numpy

X2 = [{'city':'Sydney', 'month':'July'},
      {'city':'Sydney', 'month':'December'},
      {'city':'Paris', 'month':'July'},
      {'city':'Paris', 'month':'December'}]
Y2 = ['rain', 'sun', 'sun', 'rain']

X2e = DictVectorizer(sparse=False).fit_transform(X2)

# *** Standard perceptron: can't handle this dataset ***
classifier1 = Perceptron()
classifier1.fit(X2e, Y2)
print(accuracy_score(Y2, classifier1.predict(X2e)))

import ml_lecture6

# *** SVM from scikit-learn with polynomial kernel ***
classifier2 = SVC(kernel='poly', degree=2)
classifier2.fit(X2e, Y2)
print(accuracy_score(Y2, classifier2.predict(X2e)))

# *** Our own perceptron with polynomial kernel ***
classifier3 = ml_lecture6.KernelPerceptron()
classifier3.fit(X2e, Y2)
print(accuracy_score(Y2, classifier3.predict(X2e)))

